package mpi.eudico.client.annotator.interlinear.edit;

import java.util.List;

import nl.mpi.lexan.annotyzers.Mediator;
import nl.mpi.lexan.annotyzers.helpers.Information;
import nl.mpi.lexan.annotyzers.helpers.Position;

/**
 * A wrapper for the output side of the mediator (as seen from the ELAN side!).
 * This hides the methods that should only be called by LEXAN, the input side.
 * 
 * @author Han Sloetjes
 */
public class MediatorOutConnector {
	private Mediator mediator;
	
	/**
	 * Constructor.
	 * 
	 * @param mediator the mediator to wrap
	 */
	public MediatorOutConnector(Mediator mediator) {
		this.mediator = mediator;
	}

// ##################### LEXAN side of the mediator interface ###################
	public void tierDeleted(String arg0) {
		mediator.tierDeleted(arg0);		
	}

	public boolean initAnnotyzer(List<List<String>> arg0,
			List<List<String>> arg1, Information arg2) {
		return mediator.initAnnotyzer(arg0, arg1, arg2);
	}

	public List<Information> listAnnotyzers() {
		return mediator.listAnnotyzers();
	}

	public void annotyze(Position pos) {
		mediator.annotyze(pos);
		if(mediator instanceof InterlinearMediator){
			((InterlinearMediator)mediator).interLinearizeActionCompleted();
		}
	}

//		public void annotyze(Range arg0) {
//			mediator.annotyze(arg0);
//		}

	public boolean change(Position pos) {
		return mediator.change(pos);
	}


	public void initAnnotyzers(List<String> arg0) {
		mediator.initAnnotyzers(arg0);
	}
	
	public boolean unloadAnnotyzer(List<List<String>> arg0,
			List<List<String>> arg1, Information arg2) {
		return mediator.unloadAnnotyzer(arg0, arg1, arg2);
	}


	public boolean loadState(String folderPath) {
		return mediator.loadState(folderPath);
	}

	public boolean saveState(String folderPath) {
		return mediator.saveState(folderPath);
	}
	
	// should this become part of the api?
	public void annotationDeleted(Position pos) {
		// NOTE: for now remAnnotation is called
		mediator.remAnnotation(pos);
	}
}
