package mpi.eudico.client.annotator.turnsandscenemode.commands;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import mpi.eudico.client.annotator.turnsandscenemode.TurnsAndSceneViewer;

/**
 * An action class to initiate a merge action between two cells in the annotation table of the viewer.
 * Since gaps or "virtual annotations" are in the table as well, the merge actions need to be slightly
 * different from the merge actions in the normal annotation mode.
 * 
 * @author Han Sloetjes
 */
@SuppressWarnings("serial")
public class TaSMergeAction extends AbstractAction {
	private TurnsAndSceneViewer viewer;
	public enum MERGE_ROW {
		PREVIOUS,
		NEXT
	}
	private MERGE_ROW mergeWith;

	public TaSMergeAction(TurnsAndSceneViewer viewer, MERGE_ROW rowToMergeWith) {
		super();
		this.viewer = viewer;
		mergeWith = rowToMergeWith;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (viewer != null) {
			if (mergeWith == MERGE_ROW.PREVIOUS) {
				viewer.mergeWithPreviousEventOccurred();
			} else {
				viewer.mergeWithNextEventOccurred();
			}
		}
	}

}
