package mpi.eudico.client.annotator.turnsandscenemode.commands;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import mpi.eudico.client.annotator.turnsandscenemode.TurnsAndSceneViewer;

/**
 * An action invoked after a "cut" action has occurred. 
 * 
 * The current implementation notifies the viewer so that the current text 
 * can be committed to the annotation (otherwise a check should be made 
 * when a cell is de-activated to see if anything changed).
 * 
 * @author Han Sloetjes
 *
 */
@SuppressWarnings("serial")
public class TaSPostCutAction extends AbstractAction {
	private TurnsAndSceneViewer viewer;

	public TaSPostCutAction(TurnsAndSceneViewer viewer) {
		super();
		this.viewer = viewer;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (viewer != null) {
			viewer.cutActionOccurred();// in the current row/cell	
		}
	}

}
