package mpi.eudico.client.annotator.turnsandscenemode.commands;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import mpi.eudico.client.annotator.turnsandscenemode.TurnsAndSceneViewer;


/**
 * An action invoked after a "paste" action has occurred. 
 * 
 * The current implementation notifies the viewer so that the current text 
 * (after the paste event) can be committed to the annotation (which will
 * be created in case of a paste action in a "gap".
 * 
 * @author Han Sloetjes
 *
 */
@SuppressWarnings("serial")
public class TaSPostPasteAction extends AbstractAction {
	private TurnsAndSceneViewer viewer;
	
	public TaSPostPasteAction(TurnsAndSceneViewer viewer) {
		super();
		this.viewer = viewer;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (viewer != null) {
			viewer.pasteActionOccurred();
		}
	}

}
