package mpi.eudico.client.annotator.turnsandscenemode.commands;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import mpi.eudico.client.annotator.turnsandscenemode.TurnsAndSceneViewer;

/**
 * An action that notifies the viewer that a specific keystroke occurred.
 * All the actual work is delegated to the viewer at the moment.
 * A more elegant solution can be considered later.
 */
@SuppressWarnings("serial")
public class TaSSplitAction extends AbstractAction {
	TurnsAndSceneViewer viewer;
	
	public TaSSplitAction(TurnsAndSceneViewer viewer) {
		super();
		this.viewer = viewer;
	}


	@Override
	public void actionPerformed(ActionEvent e) {
		if (viewer != null) {
			viewer.splitEventOccurred();
		}
	}

}
