package mpi.eudico.client.util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.tree.DefaultMutableTreeNode;

import mpi.eudico.server.corpora.clomimpl.abstr.TierImpl;
import mpi.eudico.server.corpora.clomimpl.abstr.TranscriptionImpl;


/**
 * Created on Apr 2, 2004
 * 
 * Create a tree from DefaultMutableTreeNodes which have
 * Tier names as String userObjects.
 *
 * @author Alexander Klassmann
 * @version Apr 2, 2004
 * @version Aug 2005 Identity removed
 */
public class TierTree {
    private DefaultMutableTreeNode[] nodes;

    /**
     * Creates a new TierTree instance
     *
     * @param transcription DOCUMENT ME!
     * @param identity DOCUMENT ME!
     */
    public TierTree(TranscriptionImpl transcription) {
        Map<TierImpl, DefaultMutableTreeNode> tierNodes = new HashMap<TierImpl, DefaultMutableTreeNode>();

        List<TierImpl> tierVector = transcription.getTiers();
        nodes = new DefaultMutableTreeNode[tierVector.size() + 1];
        nodes[0] = new DefaultMutableTreeNode();

        for (int i = 0; i < tierVector.size(); i++) {
            TierImpl tier = tierVector.get(i);
            nodes[i + 1] = new DefaultMutableTreeNode(tier.getName());
            tierNodes.put(tier, nodes[i + 1]);
        }

        for (int i = 0; i < tierVector.size(); i++) {
            TierImpl tier = tierVector.get(i);

            if (tier.hasParentTier()) {
                final DefaultMutableTreeNode parent = tierNodes.get(tier.getParentTier());
				if (parent != null) {
                    parent.add(nodes[i + 1]);
                }
            } else {
                nodes[0].add(nodes[i + 1]);
            }
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public DefaultMutableTreeNode getTree() {
        return nodes[0];
    }
}
